diff -uNr linux/drivers/char/kbd_clps7110.c linux-2.4.7/drivers/char/kbd_clps7110.c
--- linux/drivers/char/kbd_clps7110.c	Thu Jan  1 03:00:00 1970
+++ linux-2.4.7/drivers/char/kbd_clps7110.c	Wed Jul 25 03:37:54 2001
@@ -0,0 +1,293 @@
+/*
+ * arch/arm/drivers/char/kbd_7110.c - Keyboard Driver for clps7110
+ *
+ * Copyright (C) Roger Gammans  1998
+ *
+ */
+
+#include <linux/config.h>
+#include <linux/init.h>
+#include <asm/uaccess.h>
+#include <asm/arch/keyboard.h>
+#include <linux/tqueue.h>
+#include <linux/kbd_ll.h>
+#include <asm/spinlock.h>
+#include <linux/tty_flip.h>
+#include <linux/delay.h>
+#include <asm/arch/pm.h>
+
+#ifdef KB_DELAY
+unsigned int kbd_delay[] = KB_DELAY; 
+#endif
+
+static int keysdown = 0;
+
+static struct tq_struct kbdhw_task;
+
+struct tty_struct **tty;
+
+
+static void kbd_power(struct pm_device *dev,int state)
+{
+	/* @@@ add fancy power-saving features later */
+	pm_complete(dev,state);
+}
+
+
+static struct pm_device kbd_pm_dev =
+    { "keyboard", kbd_power, 1, { PM_KEYBOARD_IDLE_DEFAULT, } };
+
+/*
+ * The aim of this function is to remove 
+ * any old depressed keys which are now released from
+ * the table.
+ */
+ 
+void kbd7110_cleartable(void) {
+int key;
+int flags;
+unsigned int t;
+
+    for (key=0; key<NR_KEYCODES; key++) {
+         if (kbdstate[key].in) {
+             /*
+              * dont worry these ops are commutative and
+              * assoicative 
+              */
+             t = (jiffies - kbdstate[key].jif) & KB_JIFMASK; 
+             if (t>KB_DEB_JIFFY) {
+
+             /* Yes, the keboard could have changed in the meanwhile
+              * but it hardly matters, and there nothing we can
+              * do to remove the possibly of short key ups 
+              */
+						
+                 spin_lock_irqsave(&kbd_spinlock,flags);
+                 kbdstate[key].in= 0;
+                 keysdown--;
+                 /*printk("Releasing key:%x\n",key);*/
+                 spin_unlock_irqrestore(&kbd_spinlock,flags);
+                 handle_scancode(KBSCANCDE(key,KBUP));
+             }
+         }
+    }
+
+}
+
+
+
+static void kbd_press(int keycode) {
+
+   unsigned long flags;
+   unsigned char newpress = 0;
+
+   spin_lock_irqsave(&kbd_spinlock,flags);
+   if (!kbdstate[keycode].in) {
+       keysdown++; 
+       newpress = 1;
+       /*printk("Found key down: %x\n",keycode);*/
+   }
+
+  /*
+   * We approximate a retriggable monostable
+   * action.
+   */
+    
+    kbdstate[keycode].in=1;
+    spin_unlock_irqrestore(&kbd_spinlock,flags);
+   /* We only need to ensure keysdown consistent */
+  
+    kbdstate[keycode].jif = jiffies & KB_JIFMASK;
+    if (newpress) {
+	pm_activity(&kbd_pm_dev);
+	handle_scancode(KBSCANCDE(keycode,KBDOWN));
+    }
+}
+
+
+
+
+static void kbd7110_tick(void* dummy) {
+    int col,row;
+    int rowd;
+    int count=0;
+   
+    /*
+     * we first check to see if any keys are depressed
+     */
+#ifdef KBD_SUPPORTS_WIRE_OR
+    KB_COL(ALLROWS)
+    if (KB_ROW) 
+#endif
+        for(col=0; col<8; col++) {
+
+#ifdef KB_DISCHARGE
+            /*
+             * Discharge the output driver capacitatance
+             * in the keyboard matrix. (Yes it is significant..)
+             */
+            KB_COL(KB_DISCHARGE);
+#ifdef KB_DELAY
+            udelay(kbd_delay[8]);
+#endif
+#endif
+            KB_COL(col);
+#ifdef KB_DELAY
+	    udelay(kbd_delay[col]);
+#endif
+            rowd = KB_ROW;
+            if (rowd) {
+                for (row=0; row < KB_LASTROW; row++) {
+                    if (rowd & KB_ROWMASK(row)) {
+                        kbd_press(KEYCODE(row,col));
+			count++;
+		    }
+                }
+            }
+
+        };
+    
+    if (count!=keysdown) {
+        kbd7110_cleartable();
+    }
+
+   /*
+    * Re-queue ourselves
+    */
+   queue_task(&kbdhw_task,&tq_timer);
+}
+
+
+
+#ifdef CONFIG_VT
+void kbd7110_hw_init(void) { 
+#else
+void kbd_init(struct tty_struct **atty)   {
+  tty=atty;
+#endif
+
+  printk("Initialising keyboard\n");
+  pm_register(&kbd_pm_dev,1);
+  kbdhw_task.routine = kbd7110_tick;
+  kbdhw_task.sync = 0;
+  queue_task(&kbdhw_task,&tq_timer);
+
+}
+
+
+/*
+ * (the rest of the) Kernel interface functions..
+ */
+#ifndef CONFIG_VT
+   
+void handle_scancode(unsigned char code) {
+  /*
+   * Really simple just shove the scan code straight in the flip
+   * buffer for now..
+  */
+    if (*tty) {
+        tty_insert_flip_char(*tty,code,0); 
+        tty_schedule_flip(*tty);
+    } else printk("discarding scancode\n");
+}
+
+#else
+
+ /*
+  *  I was hoping to divorce the VT's keyboard handler but
+  *  it turn out to be harder than I'd hoped....
+  *  we'll re-instate this lot when the lcd driver get closer
+  *  to integration with the vt code.
+  *                                  RGG
+  */
+ 
+int kbd7110_translate(unsigned char scancode, unsigned char *keycode_p)
+{
+
+ /*
+  * We do this strangley to be more independent of 
+  * our headers..
+  */
+
+  *keycode_p = scancode & ~(KBDOWN | KBUP);
+
+  return 1;
+}
+
+#endif
+
+
+#if defined(CONFIG_VT) && defined(CONFIG_MAGIC_SYSRQ)
+extern int sysrq_pressed;
+#endif
+
+
+void kbd7110_arch_handler(unsigned char value, char up_flag)
+{
+#if defined(CONFIG_VT) && defined(CONFIG_MAGIC_SYSRQ)
+	if (value == 1) {
+		sysrq_pressed = !up_flag;
+		return;
+	}
+#endif
+	if (up_flag) return;
+	switch (value) {
+#ifdef KBD_ARCHKEY_2
+		case 2:
+			KBD_ARCHKEY_2;
+			break;
+#endif
+#ifdef KBD_ARCHKEY_3
+		case 3:
+			KBD_ARCHKEY_3;
+			break;
+#endif
+#ifdef KBD_ARCHKEY_4
+		case 4:
+			KBD_ARCHKEY_4;
+			break;
+#endif
+#ifdef KBD_ARCHKEY_5
+		case 5:
+			KBD_ARCHKEY_5;
+			break;
+#endif
+#ifdef KBD_ARCHKEY_6
+		case 6:
+			KBD_ARCHKEY_6;
+			break;
+#endif
+#ifdef KBD_ARCHKEY_7
+		case 7:
+			KBD_ARCHKEY_7;
+			break;
+#endif
+#ifdef KBD_ARCHKEY_8
+		case 8:
+			KBD_ARCHKEY_8;
+			break;
+#endif
+#ifdef KBD_ARCHKEY_9
+		case 9:
+			KBD_ARCHKEY_9;
+			break;
+#endif
+#ifdef KBD_ARCHKEY_10
+		case 10:
+			KBD_ARCHKEY_10;
+			break;
+#endif
+#ifdef KBD_ARCHKEY_11
+		case 11:
+			KBD_ARCHKEY_11;
+			break;
+#endif
+		default:
+			return;
+	}
+}
+
+
+void __init kbd_reset_setup(char *str, int *ints)
+{
+}
diff -uNr linux/drivers/char/kbd_psion.c linux-2.4.7/drivers/char/kbd_psion.c
--- linux/drivers/char/kbd_psion.c	Thu Jan  1 03:00:00 1970
+++ linux-2.4.7/drivers/char/kbd_psion.c	Wed Jul 25 03:37:54 2001
@@ -0,0 +1,170 @@
+/*
+ * kbd_psion.c - Psion-specific keyboard functions
+ *
+ * Written 1999 by Werner Almesberger
+ */
+
+
+#include <linux/config.h>
+#include <linux/types.h>
+#include <asm/system.h>
+#include <asm/hardware.h>
+#include <asm/keyboard.h>
+#include <asm/arch/pm.h>
+
+
+#ifdef CONFIG_MAGIC_SYSRQ
+unsigned char kbd7110_sysrq_xlate[] =
+    "\000" "6"    "5"    "4"    "3"    "2"    "1"    "\000"
+    "\000" "'"    "\000" "0"    "9"    "8"    "7"    "\000"
+    "\000" "y"    "t"    "r"    "e"    "w"    "q"    "\000"
+    "\000" "\012" "l"    "p"    "o"    "i"    "u"    "\000"
+    "\000" "g"    "f"    "d"    "s"    "a"    "\011" "\000"
+    "\000" "\000" "."    "m"    "k"    "j"    "h"    "\000"
+    "\000" "n"    "b"    "v"    "c"    "x"    "z"    "\000"
+    "\000" "\000" "\000" ","    "\000" " "    "\000";
+#endif
+
+
+void psion_off(void)
+{
+	pm_switch(PM_SWITCH_TOGGLE);
+}
+
+
+static void backlight_power(struct pm_device *dev,int state)
+{
+	if (state) HW_ELEN_PORT |= HW_ELEN_BIT;
+	else HW_ELEN_PORT &= ~HW_ELEN_BIT;
+	pm_complete(dev,state);
+}
+
+
+struct pm_device backlight_pm_dev =
+    { "backlight", backlight_power, 1, { PM_BACKLIGHT_IDLE_DEFAULT, } };
+
+
+void psion_toggle_backlight(void)
+{
+	pm_change(&backlight_pm_dev,!backlight_pm_dev.goal);
+}
+
+
+/*
+ * Contrast table. Upper four bits: output value, lower four bits: direction
+ * (0 = in = Z)
+ */
+
+#define V0 0
+#define V1 1
+#define VZ 0
+#define D0 1
+#define D1 1
+#define DZ 0
+
+#define C(a,b,c,d) \
+    ((V##a << 7) | (V##b << 6) | (V##c << 5) | (V##d << 4) | \
+     (D##a << 3) | (D##b << 2) | (D##c << 1) | D##d)
+    
+static __u8 contrast_table[] = {
+    C(1,1,1,1), C(1,1,1,Z), C(1,1,1,0), C(1,1,Z,1),	/*  1- 4 */
+    C(1,1,Z,Z), C(1,1,0,1), C(1,1,Z,0), C(1,Z,1,1),	/*  5- 8 */
+    C(1,1,0,0), C(1,Z,1,Z), C(1,Z,1,0), C(1,Z,Z,1),	/*  9-12 */
+    C(1,0,1,1), C(1,Z,Z,Z), C(1,Z,0,1), C(1,0,1,Z),	/* 13-16 */
+    C(1,0,1,0), C(1,0,Z,1), C(1,Z,0,0), C(Z,1,1,Z),	/* 17-20 */
+    C(1,0,Z,Z), C(1,0,0,1), C(1,0,Z,0), C(1,0,0,Z),	/* 21-24 */
+    C(Z,1,Z,Z), C(1,0,0,0), C(Z,1,Z,0), C(Z,1,0,Z),	/* 25-28 */
+    C(Z,1,0,0), C(Z,Z,1,Z), C(Z,Z,1,0), C(Z,Z,Z,1),	/* 29-32 */
+    C(0,1,1,0), C(0,1,Z,1), C(Z,Z,0,1), C(Z,0,1,Z),	/* 33-36 */
+    C(0,1,Z,Z), C(Z,Z,0,Z), C(0,1,Z,0), C(Z,Z,0,0),	/* 37-40 */
+    C(0,1,0,Z), C(Z,0,Z,Z), C(0,1,0,0), C(Z,0,Z,0),	/* 41-44 */
+    C(0,Z,1,0), C(0,Z,Z,1), C(Z,0,0,0), C(0,0,1,1),	/* 45-48 */
+    C(0,Z,Z,Z), C(0,Z,0,1), C(0,Z,Z,0), C(0,0,1,0),	/* 49-52 */
+    C(0,0,Z,1), C(0,Z,0,0), C(0,0,Z,Z), C(0,0,0,1),	/* 53-56 */
+    C(0,0,Z,0), C(0,0,0,Z), C(0,0,0,0)			/* 57-60 */
+};
+
+
+void psion_contrast(int increase)
+{
+	static int contrast = 24;
+
+	if (increase)
+		if (contrast == sizeof(contrast_table)-1) return;
+		else contrast++;
+	else if (!contrast) return;
+		else contrast--;
+	HW_VLD_PORT = (HW_VLD_PORT & ~HW_VLD_MASK) |
+	    ((contrast_table[contrast] >> 4) << HW_VLD_SHIFT);
+	HW_VLD_DIR = (HW_VLD_DIR & ~HW_VLD_MASK) |
+	    ((contrast_table[contrast] & 0xf) << HW_VLD_SHIFT);
+}
+
+
+int led_during_standby = 0;
+
+
+void psion_debug_power_led(void)
+{
+	led_during_standby = !led_during_standby;
+	printk("LED is %slit during CPU standby\n",
+	    led_during_standby ? "" : "NOT ");
+}
+
+
+#include <asm/irq.h>
+
+
+#if 0
+static void p_(const char *l)
+{
+   printk("%-10s CCSR=%02x PRR=%02x Sta=%02x ISR=%04x/%04x ETNA=0x%02x/0x%02x;0x%02x\n",l,
+     *(u8 *) PCMCIA_ATTR8(0x202),*(u8 *) PCMCIA_ATTR8(0x204),
+     *(u8 *) PCMCIA_IO8(0x3f6),IO_INTSR & 0xffff,IO_INTMR  &0xffff,
+     IO_ETNA_INT_STATUS,IO_ETNA_INT_MASK,__ETNAB(11));
+}
+
+static void pdc_irq(int irq,void *dev_id,struct pt_regs *regs)
+{
+   printk("YEEEEEEEEEAAAHHH!!! (0x%02x)\n",*(u8 *) PCMCIA_IO8(0x1f7));
+   IO_ETNA_INT_CLEAR = ETNA_CF_IRQ;
+}
+
+void psion_debug_cf(void)
+{
+    int i;
+
+printk("COR 0x%02x .. set to 2\n",*(u8 *) PCMCIA_ATTR8(0x200));
+     *(u8 *) PCMCIA_ATTR8(0x200) = 2;
+return;
+    if (request_irq(IRQ_EINT1,pdc_irq,0,"cf",NULL))
+	printk("IRQ: grr\n");
+    enable_irq(IRQ_EINT1);
+    printk("COR 0x%02x\n",*(u8 *) PCMCIA_ATTR8(0x200));
+    p_("---");
+    IO_ETNA_INT_CLEAR = ETNA_CF_IRQ;
+    IO_ETNA_INT_MASK = ETNA_CF_IRQ;
+    p_("ETNA");
+     *(u8 *) PCMCIA_ATTR8(0x200) = 0x42;
+    p_("COR=0x42");
+    *(u8 *) PCMCIA_ATTR8(0x202) = 0x40;
+    p_("CCSR=0x40");
+    *(u8 *) PCMCIA_ATTR8(0x204) = 2;
+    p_("PRR=2");
+    *(u8 *) PCMCIA_ATTR8(0x204) = 0;
+    p_("PRR=0");
+    *(u8 *) PCMCIA_IO8(0x3f6) = 0;
+    p_("DCR=0");
+    *(u8 *) PCMCIA_IO8(0x1f2) = 1;
+    p_("#sec=1");
+    *(u8 *) PCMCIA_IO8(0x1f3) = 0;
+    *(u8 *) PCMCIA_IO8(0x1f4) = 0;
+    *(u8 *) PCMCIA_IO8(0x1f5) = 0;
+    p_("LBA=0");
+    *(u8 *) PCMCIA_IO8(0x1f6) = 0xe0;
+    p_("CDH=0xe0");
+    *(u8 *) PCMCIA_IO8(0x1f7) = 0x20;
+    p_("CMD=0x20");
+    for (i = 0; i < 10; i++) p_("...");
+}
+#endif
diff -uNr linux/drivers/char/serial_clps711x.c linux-2.4.7/drivers/char/serial_clps711x.c
--- linux/drivers/char/serial_clps711x.c	Fri Aug  3 05:40:01 2001
+++ linux-2.4.7/drivers/char/serial_clps711x.c	Tue Nov 27 02:25:38 2001
@@ -55,9 +55,13 @@
 
 #include <linux/serial_core.h>
 
-#include <asm/hardware/clps7111.h>
+#include <asm/hardware/clps711x.h>
 
+#if defined(CONFIG_ARCH_CLPS7110)
+#define UART_NR		1
+#else
 #define UART_NR		2
+#endif
 
 #define SERIAL_CLPS711X_NAME	"ttyAM"
 #define SERIAL_CLPS711X_MAJOR	204
@@ -422,14 +426,16 @@
 		uartclk:	3686400,
 		fifosize:	16,
 		ops:		&clps711x_pops,
-	},
-	{
+	}
+#if !defined(CONFIG_ARCH_CLPS7110)
+	,{
 		iobase:		SYSCON2 - SYSCON1,
 		irq:		IRQ_UTXINT2, /* IRQ_URXINT2 */
 		uartclk:	3686400,
 		fifosize:	16,
 		ops:		&clps711x_pops,
 	}
+#endif
 };
 
 #ifdef CONFIG_SERIAL_CLPS711X_CONSOLE
diff -uNr linux/drivers/pcmcia/Config.in linux-2.4.7/drivers/pcmcia/Config.in
--- linux/drivers/pcmcia/Config.in	Fri Aug  3 05:40:02 2001
+++ linux-2.4.7/drivers/pcmcia/Config.in	Fri Aug 10 02:57:15 2001
@@ -25,5 +25,6 @@
 fi
 dep_tristate '  CLPS6700 support' CONFIG_PCMCIA_CLPS6700 $CONFIG_ARCH_CLPS711X $CONFIG_PCMCIA
 dep_tristate '  SA1100 support' CONFIG_PCMCIA_SA1100 $CONFIG_ARCH_SA1100 $CONFIG_PCMCIA
+dep_tristate '  Psion ETNA support' CONFIG_PCMCIA_ETNA $CONFIG_PCMCIA
 
 endmenu
diff -uNr linux/drivers/pcmcia/Makefile linux-2.4.7/drivers/pcmcia/Makefile
--- linux/drivers/pcmcia/Makefile	Fri Aug  3 05:40:02 2001
+++ linux-2.4.7/drivers/pcmcia/Makefile	Fri Aug 10 00:50:49 2001
@@ -55,6 +55,7 @@
 
 obj-$(CONFIG_PCMCIA_CLPS6700)	+= clps6700.o
 obj-$(CONFIG_PCMCIA_SA1100)	+= sa1100_cs.o
+obj-$(CONFIG_PCMCIA_ETNA)	+= clps711x_etna.o
 
 sa1100_cs-objs-y				:= sa1100_generic.o
 sa1100_cs-objs-$(CONFIG_SA1100_ASSABET)		+= sa1100_assabet.o
diff -uNr linux/drivers/pcmcia/clps6700.c linux-2.4.7/drivers/pcmcia/clps6700.c
--- linux/drivers/pcmcia/clps6700.c	Fri Aug  3 05:40:02 2001
+++ linux-2.4.7/drivers/pcmcia/clps6700.c	Thu Aug  9 06:11:34 2001
@@ -32,7 +32,7 @@
 #include <asm/page.h>
 
 #include <asm/arch/syspld.h>
-#include <asm/hardware/clps7111.h>
+#include <asm/hardware/clps711x.h>
 
 #include <pcmcia/version.h>
 #include <pcmcia/cs_types.h>
diff -uNr linux/drivers/pcmcia/clps711x_etna.c linux-2.4.7/drivers/pcmcia/clps711x_etna.c
--- linux/drivers/pcmcia/clps711x_etna.c	Thu Jan  1 03:00:00 1970
+++ linux-2.4.7/drivers/pcmcia/clps711x_etna.c	Fri Aug 10 03:00:09 2001
@@ -0,0 +1,573 @@
+/*
+ * psion_etna.c - Psion-specific PCMCIA functions
+ * 
+ * Copyright (C) 2001 Tony Lindgren <tony@atomide.com>
+ * Copyright (C) 2001 Shane Nay <shane@place.org>
+ * 
+ * Contains code from the clps6700 driver for linux,
+ * Copyright (C) 2000 Deep Blue Solutions Ltd
+ *
+ * Contains code from the Psion 5 ETNA driver for linux, 
+ * Copyright (C) 1999 Werner Almesberger.
+ *
+ *
+ * TO DO LIST 20010516
+ * - What turns on the /dev/hda?
+ * - What triggers the card removal interrupt?
+ * - What's the purpose of the INT_EXTFIQ?
+ * - Can all the interrupt handling be moved to this driver?
+ * - The interrupt masks in irqs.h need to be checked for 
+ *   INT1_IRQS and INT1_ACK_IRQS
+ * - What's the purpose and order of ETNA_MEM_BASE and ETNA_REG_BASE?
+ * - What is Port B bit 0x80 what powers on the cf slot?
+ * - What's the PCIILR for 2.2 kernel?
+ *
+ */
+
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/malloc.h>
+#include <linux/errno.h>
+#include <linux/sched.h>
+#include <linux/proc_fs.h>
+#include <linux/spinlock.h>
+#include <linux/init.h>
+
+#include <linux/delay.h>
+
+#include <asm/io.h>
+#include <asm/irq.h>
+#include <asm/hardware.h>
+#include <asm/page.h>
+
+#include <asm/hardware/clps711x.h>
+
+#include <pcmcia/version.h>
+#include <pcmcia/cs_types.h>
+#include <pcmcia/ss.h>
+
+#include <pcmcia/cs_types.h>
+#include <pcmcia/cs.h>
+#include <pcmcia/bus_ops.h>
+
+#include "clps711x_etna.h"
+
+#define DEBUG 1
+
+MODULE_AUTHOR("Tony Lindgren");
+MODULE_DESCRIPTION("PSION ETNA PCMCIA socket driver");
+
+#define NR_ETNA		1
+
+struct etna_skt {
+	u_int			nr;
+	u_int			physbase;
+	u_int			regbase;
+	u_int			pmr;
+	u_int			cpcr;
+	u_int			cpcr_3v3;
+	u_int			cpcr_5v0;
+	u_int			cur_pmr;
+	u_int			cur_cicr;
+	u_int			cur_pcimr;
+	u_int			cur_cpcr;
+	void			(*handler)(void *, u_int);
+	void			*handler_info;
+
+	u_int			ev_pending;
+	spinlock_t		ev_lock;
+};
+
+static struct etna_skt *skts[NR_ETNA];
+
+
+static int etna_sock_init(u_int sock)
+{
+	struct etna_skt *skt = skts[sock];
+
+	printk("-1- We are in etna_sock_init\n");
+
+	skt->cur_cicr  = 0;
+	skt->cur_pmr   = skt->pmr;
+	skt->cur_pcimr = 0;
+	skt->cur_cpcr  = skt->cpcr;
+
+#ifdef DEBUG
+	printk("skt%d: sock_init()\n", sock);
+#endif
+	return 0;
+}
+
+static int etna_suspend(u_int sock)
+{
+	printk("We are in etna_suspend\n");
+	return 0;
+}
+
+static int etna_register_callback(u_int sock, void (*handler)(void *, u_int), 
+				  void *info)
+{
+	struct etna_skt *skt = skts[sock];
+
+	printk("-3- We are in etna_register_callback\n");
+
+#ifdef DEBUG
+	printk("skt%d: register_callback: %p (%p)\n", sock, handler, info);
+#endif
+
+	skt->handler_info = info;
+	skt->handler = handler;
+
+	return 0;
+}
+
+static int etna_inquire_socket(u_int sock, socket_cap_t *cap)
+{
+
+	printk("-2- We are in etna_inquire_socket\n");
+
+	cap->features = SS_CAP_PCCARD | SS_CAP_STATIC_MAP | SS_CAP_MEM_ALIGN;
+	cap->irq_mask = 0;		/* available IRQs for this socket */
+	cap->map_size = PAGE_SIZE;	/* minimum mapping size */
+	cap->pci_irq  = 0;		/* PCI interrupt number */
+	cap->cb_dev   = NULL;
+	cap->bus      = NULL;
+	return 0;
+}
+
+
+static int __etna_get_status(struct etna_skt *skt)
+{
+	unsigned int v, val;
+
+	printk("--- We are in __etna_get_status\n");
+	
+	v = ETNA_INT_STATUS;
+	val = 0;
+
+	/* Force ready */
+	val &= ~SS_BATWARN;
+	val &= ~SS_BATDEAD;
+	val &= ~SS_XVCARD;
+	val |= SS_DETECT;
+	val |= SS_READY;
+	val |= SS_3VCARD;
+	
+	// Clear pending status. What sets this on?
+	val &= ~SS_PENDING;
+
+
+#ifdef DEBUG
+	printk("skt%d: PCIILR: %08x -> (%s %s %s %s %s %s)\n",
+		skt->nr, v,
+	        val & SS_READY   ? "rdy" : "---",
+	        val & SS_DETECT  ? "det" : "---",
+	        val & SS_BATWARN ? "bw"  : "--",
+		val & SS_BATDEAD ? "bd"  : "--",
+		val & SS_3VCARD  ? "3v"  : "--",
+		val & SS_XVCARD  ? "xv"  : "--");
+
+#endif
+	return val;
+}
+
+static int etna_get_status(u_int sock, u_int *valp)
+{
+	struct etna_skt *skt = skts[sock];
+	*valp = __etna_get_status(skt);
+	return 0; /* not used! */
+}
+
+static int etna_get_socket(u_int sock, socket_state_t *state)
+{
+	printk("We are in etna_get_socket\n");
+	return -EINVAL;
+}
+
+static int etna_set_socket(u_int sock, socket_state_t *state)
+{
+	struct etna_skt *skt = skts[sock];
+	unsigned long flags;
+	u_int cpcr = skt->cur_cpcr, pmr = skt->cur_pmr, cicr = skt->cur_cicr;
+	u_int pcimr = 0;
+
+	printk("We are in etna_set_socket with sock=%d\n", sock);
+	printk("skt->regbase = 0x%x\n", skt->regbase);
+
+
+	cicr &= ~(CICR_ENABLE | CICR_RESET | CICR_IOMODE);
+
+	if (state->flags & SS_PWR_AUTO)
+		pmr |= PMR_DCAR | PMR_PDCR;
+
+	/*
+	 * Note! We must NOT assert the Card Enable bit until reset has
+	 * been de-asserted.  Some cards indicate not ready, which then
+	 * hangs our next access.  (Bug in CLPS6700?)
+	 */
+
+	if (state->flags & SS_RESET)
+		cicr |= CICR_RESET | CICR_RESETOE;
+	else if (state->flags & SS_OUTPUT_ENA)
+		cicr |= CICR_ENABLE;
+
+	if (state->flags & SS_IOCARD) {
+		cicr |= CICR_IOMODE;
+
+
+	/* if (state->csc_mask & SS_STSCHG)*/
+
+	} else {
+		if (state->csc_mask & SS_BATDEAD)
+			pcimr |= PCM_BVD2;
+		if (state->csc_mask & SS_BATWARN)
+			pcimr |= PCM_BVD1;
+		if (state->csc_mask & SS_READY)
+			pcimr |= PCM_RDYL;
+	}
+
+	if (state->csc_mask & SS_DETECT)
+		pcimr |= PCM_CD1 | PCM_CD2;
+
+	switch (state->Vcc) {
+	case 0:				break;
+	case 33: cpcr |= skt->cpcr_3v3; pmr |= PMR_CPE; break;
+	case 50: cpcr |= skt->cpcr_5v0; pmr |= PMR_CPE; break;
+	default: return -EINVAL;
+	}
+
+#ifdef DEBUG
+	printk("skt%d: PMR: %04x, CPCR: %04x, CICR: %04x PCIMR: %04x "
+		"(Vcc = %d, flags = %c%c%c%c, csc = %c%c%c%c%c)\n",
+		sock, pmr, cpcr, cicr, pcimr, state->Vcc,
+		state->flags & SS_RESET      ? 'r' : '-',
+		state->flags & SS_PWR_AUTO   ? 'p' : '-',
+		state->flags & SS_IOCARD     ? 'i' : '-',
+		state->flags & SS_OUTPUT_ENA ? 'o' : '-',
+		state->csc_mask & SS_STSCHG  ? 's' : '-',
+		state->csc_mask & SS_BATDEAD ? 'd' : '-',
+		state->csc_mask & SS_BATWARN ? 'w' : '-',
+		state->csc_mask & SS_READY   ? 'r' : '-',
+		state->csc_mask & SS_DETECT  ? 'c' : '-');
+#endif
+
+	save_flags_cli(flags);
+
+	if (skt->cur_cpcr != cpcr) {
+		skt->cur_cpcr = cpcr;
+		////__raw_writel(skt->cur_cpcr, skt->regbase + CPCR);
+	}
+
+	if (skt->cur_pmr != pmr) {
+		skt->cur_pmr = pmr;
+		////__raw_writel(skt->cur_pmr, skt->regbase + PMR);
+	}
+	if (skt->cur_pcimr != pcimr) {
+		skt->cur_pcimr = pcimr;
+		////__raw_writel(skt->cur_pcimr, skt->regbase + PCIMR);
+	}
+	if (skt->cur_cicr != cicr) {
+		skt->cur_cicr = cicr;
+		////__raw_writel(skt->cur_cicr, skt->regbase + CICR);
+	}
+
+	restore_flags(flags);
+
+	return 0;
+}
+
+static int etna_get_io_map(u_int sock, struct pccard_io_map *io)
+{
+	return -EINVAL;
+}
+
+static int etna_set_io_map(u_int sock, struct pccard_io_map *io)
+{
+	printk("We are in etna_set_io_map\n");
+	printk("skt%d: iomap: %d: speed %d, flags %X start %X stop %X\n",
+		sock, io->map, io->speed, io->flags, io->start, io->stop);
+	return 0;
+}
+
+static int etna_get_mem_map(u_int sock, struct pccard_mem_map *mem)
+{
+	printk("We are in etna_get_mem_map\n");
+	return -EINVAL;
+}
+
+/*
+ * Set the memory map attributes for this socket.  (ie, mem->speed)
+ * Note that since we have SS_CAP_STATIC_MAP set, we don't need to do
+ * any mapping here at all; we just need to return the address (suitable
+ * for ioremap) to map the requested space in mem->sys_start.
+ *
+ * flags & MAP_ATTRIB indicates whether we want attribute space.
+ */
+static int etna_set_mem_map(u_int sock, struct pccard_mem_map *mem)
+{
+	struct etna_skt *skt = skts[sock];
+	u_int off;
+
+	if (mem->flags & MAP_ATTRIB)
+		off = ETNA_ATTRIB_BASE;
+	else
+		off = ETNA_MEM_BASE;	
+
+	mem->sys_start  = skt->physbase + off;
+	mem->sys_start += mem->card_start;
+
+        //printk("mem->sys_start=0x%x\n", mem->sys_start);
+
+	return 0;
+}
+
+static void etna_proc_setup(u_int sock, struct proc_dir_entry *base)
+{
+}
+
+static struct pccard_operations etna_operations = {
+	init:			etna_sock_init,
+	suspend:		etna_suspend,
+	register_callback:	etna_register_callback,
+	inquire_socket:		etna_inquire_socket,
+	get_status:		etna_get_status,
+	get_socket:		etna_get_socket,
+	set_socket:		etna_set_socket,
+	get_io_map:		etna_get_io_map,
+	set_io_map:		etna_set_io_map,
+	get_mem_map:		etna_get_mem_map,
+	set_mem_map:		etna_set_mem_map,
+	proc_setup:		etna_proc_setup
+};
+
+static void etna_bh(void *dummy)
+{
+	int i;
+
+	printk("We are in etna_bh\n");
+
+	for (i = 0; i < NR_ETNA; i++) {
+		struct etna_skt *skt = skts[i];
+		unsigned long flags;
+		u_int events;
+
+		if (!skt)
+			continue;
+
+		/*
+		 * Note!  We must read the pending event state
+		 * with interrupts disabled, otherwise we race
+		 * with our own interrupt routine!
+		 */
+		spin_lock_irqsave(&skt->ev_lock, flags);
+		events = skt->ev_pending;
+		skt->ev_pending = 0;
+		spin_unlock_irqrestore(&skt->ev_lock, flags);	
+
+		if (skt->handler && events)
+			skt->handler(skt->handler_info, events);
+	}
+}
+
+static struct tq_struct etna_task = {
+	routine:	etna_bh
+};
+
+static void etna_interrupt(int irq, void *dev_id, struct pt_regs *regs)
+{
+	struct etna_skt *skt = dev_id;
+	u_int val, events;
+
+	printk("We are in etna_interrupt\n");
+
+	val = ETNA_INT_STATUS;
+	printk("Etna int status val = %d\n", val);
+	if (!val) {
+		printk("No card in slot\n");
+		return;
+	}
+
+	events = 0;
+	
+	/* Force socket ready for ETNA */
+	events |= SS_DETECT;
+	events |= SS_READY;
+
+	spin_lock(&skt->ev_lock);
+	skt->ev_pending |= events;
+	spin_unlock(&skt->ev_lock);
+	schedule_task(&etna_task);
+}
+
+
+static int __init etna_init_skt(int nr)
+{
+	struct etna_skt *skt;
+	int ret;
+
+	servinfo_t info;
+
+	printk("We are int etna_init_skt\n");
+
+	skt = kmalloc(sizeof(struct etna_skt), GFP_KERNEL);
+	if (!skt)
+		return -ENOMEM;
+
+	memset(skt, 0, sizeof(struct etna_skt));
+
+	spin_lock_init(&skt->ev_lock);
+
+	skt->nr       = nr;
+	skt->physbase = nr ? 0x50000000 : 0x40000000;
+	printk("skt->physbase=0x%x\n", skt->physbase);
+
+	skt->pmr      = PMR_AUTOIDLE | PMR_MCPE | PMR_CDWEAK;
+	skt->cpcr     = CPCR_PDIR(PCTL1|PCTL0);
+	skt->cpcr_3v3 = CPCR_PON(PCTL0);
+	skt->cpcr_5v0 = CPCR_PON(PCTL0);	// we only do 3v3
+
+	skt->cur_pmr  = skt->pmr;
+
+	//skt->regbase = (u_int)__ioremap(skt->physbase, PCMCIA_SIZE, 0);
+	//skt->regbase = PCMCIA_V_BASE;
+	//skt->regbase = (u_int)__ioremap(skt->physbase + CLPS6700_REG_BASE,
+	//				CLPS6700_REG_SIZE, 0);
+
+	skt->regbase = (u_int)__ioremap(skt->physbase + ETNA_IO_BASE,
+					ETNA_REG_SIZE, 0);
+
+	////skt->regbase = PCMCIA_V_BASE + ETNA_REG_BASE;
+
+	//skt->regbase = ETNA_V_BASE + ETNA_IO_BASE;
+	//skt->regbase = skt->physbase;
+
+	ret = -ENOMEM;
+	if (!skt->regbase)
+		goto err_free;
+
+	skts[nr] = skt;
+
+
+	/*
+	 * Here are the interrupts. See also arch/arm/mach-psionw/irq.c 
+	 * for the triggers.
+	 */
+
+	// This seems to work on insert, but don't know how to reset
+	//ret = request_irq(IRQ_EXTFIQ, etna_interrupt,
+	//		  SA_SHIRQ, "pcmcia", skt);
+
+	// No luck so far with this one
+	//ret = request_irq(IRQ_MCINT, etna_interrupt,
+	//	  SA_SHIRQ, "pcmcia", skt);
+
+	// This works on inserting the card
+	ret = request_irq(IRQ_EINT1, etna_interrupt,
+			  SA_SHIRQ, "pcmcia", skt);
+
+	// Let's get rid of this
+	//ret = request_irq(IRQ_TC1OI, etna_interrupt,
+	//		  SA_SHIRQ, "pcmcia", skt);
+
+	if (ret) {
+		printk(KERN_ERR "Psion ETNA: unable to grab irq%d (%d)\n",
+		       IRQ_EINT1, ret);
+		goto err_unmap;
+	}
+
+	printk("Trying to get some more info\n");
+	CardServices(GetCardServicesInfo, &info);
+
+	return 0;
+
+err_unmap:
+	iounmap((void *)skt->regbase);
+err_free:
+	kfree(skt);
+	skts[nr] = NULL;
+	return ret;
+}
+
+static void etna_free_resources(void)
+{
+	int i;
+	printk("We are in etna_free_resources\n");
+	for (i = NR_ETNA; i >= 0; i--) {
+		struct etna_skt *skt = skts[i];
+		skts[i] = NULL;
+		if (skt == NULL)
+			continue;
+		free_irq(IRQ_EINT1, skt);
+		iounmap((void *)skt->regbase);
+		kfree(skt);
+	}
+}
+
+static int __init etna_init(void)
+{
+	unsigned int v;
+	int err, nr;
+
+	u8 etna_orig;
+	unsigned int t1;
+
+	printk("We are in etna_init\n");
+	/*
+	 * FIXME5MX: Add power_check and parse_cis type card detection here
+	 */
+
+	/*
+	 * FIXME5MX: Don't know if this is necessary here
+	 */
+	/* Clear ETNA interrupts */
+	printk("ETNA_INT_STATUS=0x%x\n", ETNA_INT_STATUS);
+	ETNA_INT_MASK = 0;
+	ETNA_INT_CLEAR = ETNA_CF_IRQ;
+
+/*
+	t1 = clps_readl(TC1CTRL);
+	// These bits need to initialized to 0
+	t1 &= ~TC_BIT2;
+	t1 &= ~TC_BIT4;
+	t1 &= ~TC_BIT5;
+	//t1 &= ~TC_CLKSEL;		// 2Khz mode
+	t1 |= TC_CLKSEL;		// 512kHz mode
+	t1 &= ~TC_MODE;			// Free running mode
+        //t1 |= TC_MODE;		// Periodic mode
+	t1 |= TC_ENABLE;
+	clps_writel(t1, TC1CTRL);
+	clps_writel(5119, TC1LOAD);	// 512kHz / 100Hz - 1	
+*/
+
+	/*
+	 * FIXME5MX: Add pm_register stuff here
+	 */
+	
+	for (nr = 0; nr < NR_ETNA; nr++) {
+		err = etna_init_skt(nr);
+		if (err)
+			goto free;
+	}
+
+	err = register_ss_entry(nr, &etna_operations);
+	if (err)
+		goto free;
+
+	return 0;
+
+free:
+	/*
+	 * An error occurred.  Unmap and free all ETNA
+	 */
+	etna_free_resources();
+	return err;
+}
+
+static void __exit etna_exit(void)
+{
+	unregister_ss_entry(&etna_operations);
+	etna_free_resources();
+}
+
+module_init(etna_init);
+module_exit(etna_exit);
diff -uNr linux/drivers/pcmcia/clps711x_etna.h linux-2.4.7/drivers/pcmcia/clps711x_etna.h
--- linux/drivers/pcmcia/clps711x_etna.h	Thu Jan  1 03:00:00 1970
+++ linux-2.4.7/drivers/pcmcia/clps711x_etna.h	Fri Aug 10 01:05:07 2001
@@ -0,0 +1,100 @@
+/*
+ * Port B for CF card
+ */
+#define HW_VPCEN_PORT		PBDR /* Enables the power to the CF Card */
+#define HW_VPCEN_BIT		0x80
+
+/* The order of these may not be correct */
+#define ETNA_ATTRIB_BASE	0x00000000
+#define ETNA_IO_BASE		0x04000000
+
+#define ETNA_REG_BASE		0x08000000
+#define ETNA_MEM_BASE		0x0c000000
+
+#define ETNA_REG_SIZE		0x00005000
+
+//#define PCMCIA_BASE          0xf0000000      /* virtual */
+//#define PCMCIA_ATTR8(a)      (ETNA_V_BASE+0x00000000+(a))
+//#define PCIILR	0x2		/* PC Card Interrupt Input Level Register	*/
+//#define __ETNAB(off)		__raw_readb(ETNA_V_BASE + (off))
+
+/* ########## THESE ARE FROM THE SAMPLE DRIVER ########### */
+
+#define PCISR	0x0000		/* PC Card Interrupt Status Register		*/
+#define PCIMR	0x0400		/* PC Card Interrupt Mask Register		*/
+#define PCICR	0x0800		/* PC Card Interrupt Clear Register		*/
+#define PCIOSR	0x0c00		/* PC Card Interrupt Output Select Regsiter	*/
+#define PCIRR1	0x1000		/* PC Card Interrupt Reserved Register 1	*/
+#define PCIRR2	0x1400		/* PC Card Interrupt Reserved Register 2	*/
+#define PCIRR3	0x1800		/* PC Card Interrupt Reserved Register 3	*/
+#define PCIILR	0x1c00		/* PC Card Interrupt Input Level Register	*/
+#define SICR	0x2000		/* System Interface Configuration Register	*/
+#define CICR	0x2400		/* Card Interface Configuration Register	*/
+#define PMR	0x2800		/* Power Management Register			*/
+#define CPCR	0x2c00		/* Card Power Control Register			*/
+#define CITR0A	0x3000		/* Card Interface Timing Register 0A		*/
+#define CITR0B	0x3400		/* Card Interface Timing Register 0B		*/
+#define CITR1A	0x3800		/* Card Interface Timing Register 1A		*/
+#define CITR1B	0x3c00		/* Card Interface Timing Register 1B		*/
+#define DMACR	0x4000		/* DMA Control Register				*/
+#define DIR	0x4400		/* Device Information Register			*/
+
+#define PMR_AUTOIDLE	(1 << 0)	/* auto idle mode			*/
+#define PMR_FORCEIDLE	(1 << 1)	/* force idle mode			*/
+#define PMR_PDCS	(1 << 2)	/* Power down card on standby		*/
+#define PMR_PDCR	(1 << 3)	/* Power down card on removal		*/
+#define PMR_DCAR	(1 << 4)	/* Disable card access on removal	*/
+#define PMR_CPE		(1 << 5)	/* Card power enable			*/
+#define PMR_MCPE	(1 << 6)	/* Monitor card power enable		*/
+#define PMR_PDREQLSEL	(1 << 7)	/* If set, PDREQL is a GPIO pin		*/
+#define PMR_DISSTBY	(1 << 8)	/* Disable standby			*/
+#define PMR_ACCSTBY	(1 << 9)	/* Complete card accesses before standby*/
+#define PMR_CDUNPROT	(0 << 10)	/* Card detect inputs unprotected	*/
+#define PMR_CDPROT	(1 << 10)	/* Card detect inputs protected		*/
+#define PMR_CDWEAK	(2 << 10)	/* Weak pullup except in standby	*/
+#define PMR_CDWEAKAL	(3 << 10)	/* Weak pullup				*/
+
+#define CPCR_PON(x)	((x)&7)		/* PCTL[2:0] value when PMR_CPE = 1	*/
+#define CPCR_POFF(x)	(((x)&7)<<3)	/* PCTL[2:0] value when PMR_CPE = 0	*/
+#define CPCR_PDIR(x)	(((x)&7)<<6)	/* PCTL[2:0] direction			*/
+#define CPCR_CON(x)	(((x)&1)<<9)	/* GPIO value when PMR_CPE = 1		*/
+#define CPCR_COFF(x)	(((x)&1)<<10)	/* GPIO value when PMR_CPE = 0		*/
+#define CPCR_CDIR(x)	(((x)&1)<<11)	/* GPIO direction (PMR_PDREQLSEL = 1)	*/
+#define CPCR_VS(x)	(((x)&3)<<12)	/* VS[2:1] output value			*/
+#define CPCR_VSDIR(x)	(((x)&3)<<14)	/* VS[2:1] direction			*/
+
+#define PCTL0		(1 << 0)
+#define PCTL1		(1 << 1)
+#define PCTL2		(1 << 2)
+
+#define CICR_ASRTMR1	(1 << 0)	/* Timer 1 select for attribute read	*/
+#define CICR_ASWTMR1	(1 << 1)	/* Timer 1 select for attribute write	*/
+#define CICR_IOSRTMR1	(1 << 2)	/* Timer 1 select for IO read		*/
+#define CICR_IOSWTMR1	(1 << 3)	/* Timer 1 select for IO write		*/
+#define CICR_MEMSRTMR1	(1 << 4)	/* Timer 1 select for memory read	*/
+#define CICR_MEMSWTMR1	(1 << 5)	/* Timer 1 select for memory write	*/
+#define CICR_AUTOIOSZ	(1 << 6)	/* Auto size I/O accesses		*/
+#define CICR_CAW	(1 << 7)	/* Card access width			*/
+#define CICR_IOMODE	(1 << 8)	/* IO mode select			*/
+#define CICR_ENABLE	(1 << 10)	/* Card enable				*/
+#define CICR_RESETOE	(1 << 11)	/* Card reset output enable		*/
+#define CICR_RESET	(1 << 12)	/* Card reset				*/
+
+
+#define RD_FAIL		(1 << 14)
+#define WR_FAIL		(1 << 13)
+#define IDLE		(1 << 12)
+
+#define FFOTHLD		(1 << 11)
+#define PCM_RDYL	(1 << 10)
+#define PCM_WP		(1 << 9)
+#define PCTL		(1 << 8)
+
+#define PDREQ_L		(1 << 6)
+#define PCM_VS2		(1 << 5)
+#define PCM_VS1		(1 << 4)
+
+#define PCM_CD2		(1 << 3)
+#define PCM_CD1		(1 << 2)
+#define PCM_BVD2	(1 << 1)
+#define PCM_BVD1	(1 << 0)
